from tw.api import Widget, JSLink, CSSLink, JSSource

from tw.extjs import all
from paraxip.gateway_gui_widgets import debug, extjsOverrides


class WizardJS(JSSource):
    _resources = []

    isdn_script = JSLink(link="/static/javascript/widgets_src/wizard/isdn_form.js")
    hardware_script = JSLink(link="/static/javascript/widgets_src/wizard/hardware_config_form.js")
    sip_script = JSLink(link="/static/javascript/widgets_src/wizard/sip_form.js")
    analog_script = JSLink(link="/static/javascript/widgets_src/wizard/analog_form.js")
    front_script = JSLink(link="/static/javascript/widgets_src/wizard/wizard_front_form.js")

    javascript=[isdn_script,
                hardware_script,
                sip_script,
                analog_script,
                front_script]

    # Defaults for params
    source_vars = params = ["offerVirtualBoards",
                            "src_file"]
    offerVirtualBoards = False

    def __init__(self, *args, **kw):
        super(WizardJS, self).__init__(*args, **kw)

    def update_params(self, d):
        for param in self.source_vars:
            value = getattr(self, param)
            if isinstance(value, bool):
                d[param] = str(value).lower()
        super(WizardJS, self).update_params(d)

    def post_init(self, *args, **kw):
        pass

wizard_js = WizardJS()

class WizardForm(Widget):
    wizard_js_obj = WizardJS
    
    params = js_params =   ["offerVirtualBoards",
                            "src_file"]

    template = ""

    def __init__(self, *args, **kw):
        super(WizardForm, self).__init__(*args, **kw)

    def load_src(self, src_name):
        """
        src_name == dotted.path.to.template (without .ext)
        
        """
        src_file = open(src_name)
        src_obj = src_file.read()
        src_file.close()
        return src_obj
        # Get file content from package (.egg)
        #import pkg_resources
        #return pkg_resources.resource_string(
        #      pkg_resources.Requirement.parse("pstnconfig"),
        #        "pstnconfig/static/javascript/widgets_src/wizard_form_src.js")

    def __new__(cls, *args, **kw):
        cls = Widget.__new__(cls, *args, **kw)
        d = {}

        #copy in parameters from this class to the javascript class (keeps all of the params in one place)
        for param in cls.js_params:
            value = getattr(cls, param)
            if value is not None:
                d[param] = getattr(cls, param)
                if param == "src_file":
                    cls.wizard_js_obj.src = cls.load_src(value)

        wizard_js = cls.wizard_js_obj(**d)
        cls.javascript = [wizard_js]
        return cls

