#
#  @file   Assert.py
#  @author Francis Moreau
#  date    Wed Apr 23 2008
#  
#  Description:
#
#  Type your description here
#
#  Copyright (C) 2008 Paraxip Technologies.
#  All Rights Reserved.
#

import traceback
from paraxip.infra.PyLoggingFunctions import *
from paraxip.infra.CallStack import *

def isLogAssert(in_Logger, in_Expression):
  if (not in_Expression):
    (strMethodName, strFileName, argClass) = getCallerInfo()
    __loggingStatement(in_Logger,
                       strMethodName, strFileName, getCallStack())
    return True

  return False

def logAssert(in_Logger, in_Expression):
  # Cannot call isLogAssert function instead of having almost the same code
  # because getCallerInfo() will return logAssert function instead of the
  # caller's one
  if (not in_Expression):
    (strMethodName, strFileName, argClass) = getCallerInfo()
    __loggingStatement(in_Logger,
                       strMethodName, strFileName, getCallStack())

def __loggingStatement(in_Logger,
                       in_szMethodName, in_szFileName, in_szCallStack):
    # TODO: Use C++ Assert.hpp functions instead of logging with log_fatal
  log_fatal(in_Logger, "ASSERT: Method: %s, File Name: %s\n"
                       "Call Stack:\n"
                       "%s",
                       in_szMethodName, in_szFileName, in_szCallStack)

